/*
 * clSemiLinkedList.h
 *
 *  Created on: 9 apr. 2015
 *      Author: Henk Mulder
 */
#ifndef CLSEMILINKEDLIST_H
#define CLSEMILINKEDLIST

#ifdef __OPENCL_CL_H
#include <stdbool.h>
#include <stdint.h>

/* silence IDE */
#define __global
#define __kernel
#define __constant
#else
#pragma OPENCL EXTENSION cl_khr_global_int32_base_atomics : enable
#pragma OPENCL EXTENSION cl_khr_global_int32_extended_atomics : enable
#if CL_BITNESS == 64
#pragma OPENCL EXTENSION cl_khr_int64_base_atomics : enable
#pragma OPENCL EXTENSION cl_khr_int64_extended_atomics : enable
#endif
#endif

typedef struct{
	volatile uintptr_t head;
} clSemiLinkedList;


typedef struct {
	unsigned int key;
	volatile uintptr_t next;
} clSemiLinkedListNode;

#ifdef __OPENCL_CL_H
typedef volatile uintptr_t vg_uptr_t;
typedef struct  {
	uint32_t head;
} clSemiLinkedList_32;

typedef struct  {
	unsigned int size;
	uint64_t head;
} clSemiLinkedList_64;

extern cl_mem clSemiLinkedList_create(cl_device_id, cl_context, cl_command_queue, cl_program);
#else

#define NULL (uintptr_t) 0

#if CL_PLATFORM == 2
/* nVidia */
#define loop_infinite(n) for((n) = 0; (n) < 1048576; (n)++)
#else
#define loop_infinite(n) while(1)
#endif

extern void clSemiLinkedList_init(clSemiLinkedList __global *);
extern int clSemiLinkedList_add(clSemiLinkedList __global *, clSemiLinkedListNode __global *);
#endif

#endif
